function Ped03500_tabelaMetaComissao_Controller(Ped03500_tabelaMetaComissao_Service, General, templateManager, ScreenService, ZhFilterPreferences) {

    var  mensagens = {
        valorInicial : 'Valor Inicial inválido!',
        valorFinal: 'Valor Final inválido!',
        produtoFinal: 'Produto Final não pode ser menor que o produto inicial!',
        valorComissao: 'Comissão(%) deve estar entre 0 e 100!',
        preencherCampos: 'Preencha os filtros antes de realizar o cadastro Automatico!',
        sucessoCadastro: 'Cadastro automático realizado com sucesso!',
        checkedRows: 'Selecione produtos antes de realizar o cadastro automático!'
    };

    var i = 0;

    this.openFilter = function(widget){
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    this.fieldOnChangeProduto = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        if (!(widget.getField('CDPRODUTOINI').value())) {
            widget.currentRow.CDPRODUTOFIN =  '';
            widget.currentRow.CDARVPRODFIN =  '';
            widget.currentRow.NMPRODUTOFIN = '';
            widget.getField('NMPRODUTOFIN').readOnly = true;
        } else {
            widget.getField('NMPRODUTOFIN').readOnly = false;
        }
        if (widget.getField('CDARVPRODINI').value() > widget.getField('CDARVPRODFIN').value() && widget.getField('CDARVPRODFIN').value()) {
            //ScreenService.showMessage(mensagens.produtoFinal);
            ScreenService.showMessage("Produto Final não pode ser menor que o produto inicial!");
            widget.currentRow.CDPRODUTOFIN = '';
            widget.currentRow.NMPRODUTOFIN = '';
        }
    };

    this.filterTipoOperacao = function() {
        var metavenda = templateManager.container.getWidget('METAVENDA');
        var tipooper = templateManager.container.getWidget('TIPOOPER');
        tipooper.dataSourceFilter[0].value = metavenda.currentRow.CDMETAVENDA;
        tipooper.reload();
    };

    this.saveTipoOperacao = function(widget) {
        var metavenda = templateManager.container.getWidget('METAVENDA');
        var nrseq = [];
        nrseq.push('METAVENDOPERAC');
        Ped03500_tabelaMetaComissao_Service.getNrSeq(nrseq).then(function(success) {
            widget.currentRow.CDMETAVENDA = metavenda.currentRow.CDMETAVENDA;
            widget.currentRow.NRSEQMETAVENDOP = success.dataset.data[0];
            widget.currentRow.NRORG = success.dataset.data[1];
            General.saveCrud(widget);
        });
    };

    this.getNrorg = function(){
        return templateManager.container.getWidget('TABELACOMISSAO').currentRow.NRORG;
    };

    this.filiProd = function(widget){
        var row = widget.currentRow;
        if (row.NMFILIAL == ""){
            widget.getField('NMPRODUTOINI').readOnly = true;
            widget.getField('NMPRODUTOINI').readOnlyOnEdit = true;
            widget.getField('NMPRODUTOFIN').readOnly = true;
            widget.getField('NMPRODUTOFIN').readOnlyOnEdit = true;
            widget.currentRow.NMPRODUTOINI = "";
            widget.currentRow.NMPRODUTOFIN = "";
            widget.reload();
            widget = widget.container.getWidget('ITENS');
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
            widget.reload();
        } else {
            widget.getField('NMPRODUTOINI').readOnly = !row.NMFILIAL;
            widget.getField('NMPRODUTOINI').readOnlyOnEdit = !row.NMFILIAL;
            this.prodIni(widget);
        }
    };

    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODUTOFIN').readOnly = !row.NMPRODUTOINI;
        widget.getField('NMPRODUTOFIN').readOnlyOnEdit = !row.NMPRODUTOINI;
        this.prodFin(widget);
    };

    this.prodFin = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('ITENS');
        widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: this.getNrorg()
            }
        ];
        if(row.NMPRODUTOFIN){

            if (row.CDPRODUTOINI > row.CDPRODUTOFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }

            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.CDPRODUTOINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.CDPRODUTOFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };

    this.fieldOnChangeComissao = function() {
        var widget = templateManager.container.getWidget('ITEMPRODUTO');
        if (widget.getField('VRPECOMIVEND').value() <= 0 || widget.getField('VRPECOMIVEND').value() >= 100) {
            widget.getField('VRPECOMIVEND').clearValue();
            //ScreenService.showMessage(mensagens.valorComissao);
            ScreenService.showMessage("Comissão(%) deve estar entre 0 e 100!");
            widget.reload();
        }
    };

    this.openPopupCadastroItens = function() {
        var widget = templateManager.container.getWidget('TABBEDITENS');
        if(widget._hasChildWithCheckedRows()) {
            if (widget.getField('CDFILIAL').value() && widget.getField('CDPRODUTOINI').value() && widget.getField('CDPRODUTOFIN').value()) {
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOITEM');
                widgetPopup.isVisible = true;
                ScreenService.openPopup(widgetPopup);
            } else {
                //ScreenService.showMessage(mensagens.preencherCampos);
                ScreenService.showMessage("Preencha os filtros antes de realizar o cadastro Automatico!");
            }
        } else {
            //ScreenService.showMessage(mensagens.checkedRows);
            ScreenService.showMessage("Selecione produtos antes de realizar o cadastro automático!");   
        }
    };

    this.openPopupCadastroProdutos = function() {

        var widgetPopup = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        widgetPopup.currentRow.CDMETAVENDA = widgetPopup.parent.parent.currentRow.CDMETAVENDA;
        widgetPopup.currentRow.NMMETAVENDA = widgetPopup.parent.parent.currentRow.NMMETAVENDA;
        widgetPopup.isVisible = true;
        ScreenService.openPopup(widgetPopup);
    };

    this.fieldOnChangeVRCadastro = function(field) {

        var widget = templateManager.container.getWidget('CADASTROAUTOITEM');
        var CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
        var CDPRODUTO = templateManager.container.getWidget('ITENS').currentRow.CDPRODUTO;
        var CDCOMISSAO  = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;
        var VRINICVENDA = widget.currentRow.VRINICVENDA;
        var VRFINAVENDA = widget.currentRow.VRFINAVENDA;

        if (!(widget.getField('VRINICVENDA').value())){
            widget.currentRow.VRFINAVENDA = '';
            widget.getField('VRFINAVENDA').readOnly = true;
        } else {
            if (field.name === 'VRINICVENDA'){
                if (field.value() < 0) {
                    //ScreenService.showMessage(mensagens.valorInicial);
                    ScreenService.showMessage("Valor Inicial inválido!");
                    widget.currentRow.VRINICVENDA = '';
                    widget.currentRow.VRFINAVENDA = '';
                    widget.getField('VRFINAVENDA').readOnly = true;
                } else {
                    widget.getField('VRFINAVENDA').readOnly = false;
                }
            }
            if (field.name === 'VRFINAVENDA') {
                if (field.value()) {
                    var valorInicial = parseFloat(widget.getField('VRINICVENDA').value());
                    var valorFinal = parseFloat(widget.getField('VRFINAVENDA').value());
                     if(valorInicial > valorFinal){
                        //ScreenService.showMessage(mensagens.valorFinal);
                        ScreenService.showMessage("Valor Final inválido!");
                        widget.currentRow.VRFINAVENDA = '';
                    }
                }
            }
        }

    };

    this.editComissao = function(widget){
        General.edit(widget);
        widget.currentRow.VRFINAVENDAANTIGO = widget.currentRow.VRFINAVENDA;
        i = widget.currentRow.__index;
        widget.getField('VRFINAVENDA').readOnly = false;
    };

    this.fieldOnChangeVR = function(field) {
        var widget = templateManager.container.getWidget('ITEMPRODUTO');
        var CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
        var CDPRODUTO = templateManager.container.getWidget('ITENS').currentRow.CDPRODUTO;
        var CDCOMISSAO  = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;
        var VRINICVENDA = widget.currentRow.VRINICVENDA;
        var VRFINAVENDA = widget.currentRow.VRFINAVENDA;

        if (!widget.getField('VRINICVENDA').value()){
            widget.currentRow.VRFINAVENDA = '';
            widget.getField('VRFINAVENDA').readOnly = true;
        } else {
            if (field.name === 'VRINICVENDA') {
                Ped03500_tabelaMetaComissao_Service.verificaValorInicial(VRINICVENDA, CDFILIAL, CDPRODUTO, CDCOMISSAO).then(function(response) {
                    if (response.dataset.itcomissao.length !== 0 || field.value() < 0) {
                        //ScreenService.showMessage(mensagens.valorInicial);
                        ScreenService.showMessage("Valor Inicial inválido!");
                        widget.currentRow.VRINICVENDA = '';
                        widget.currentRow.VRFINAVENDA = '';
                        widget.getField('VRFINAVENDA').readOnly = true;
                    } else {
                        widget.getField('VRFINAVENDA').readOnly = false;
                    }
                });
            }
        }

        if (widget.getField('VRFINAVENDA').value()){
            var valorFinal = parseFloat(widget.getField('VRFINAVENDA').value());
            var erro = false;
            if (field.name === 'VRFINAVENDA') {
                var valores = [
                    VRINICVENDA,
                    VRFINAVENDA
                ];
                Ped03500_tabelaMetaComissao_Service.verificaValorFinal(valores, CDFILIAL, CDPRODUTO, CDCOMISSAO).then(function(response) {
                   if ((response.dataset.itcomissao.length !== 0 || field.value() < 0) && widget.mode != "edit") {
                        if (erro === false) {
                            //ScreenService.showMessage(mensagens.valorFinal);
                            ScreenService.showMessage("Valor Final inválido!");
                            erro = true;
                        }
                        widget.currentRow.VRFINAVENDA = '';
                    } else if ((widget.mode == "edit") && (widget.currentRow.__is_new == false)){
                        if (response.dataset.itcomissao.length !== 0 || field.value() < 0) {
                            if (field.value() != widget.currentRow.VRFINAVENDAANTIGO){
                                if (widget.currentRow.__index != (widget.dataSource.data.length - 1)){
                                    if (field.value() >= widget.dataSource.data[i+1].VRINICVENDA){
                                        if (erro === false) {
                                            //ScreenService.showMessage(mensagens.valorFinal);
                                            ScreenService.showMessage("Valor Final inválido!");
                                            erro = true;
                                        }
                                        widget.currentRow.VRFINAVENDA = '';
                                    }
                                }
                            }
                        }
                    } else {
                         Ped03500_tabelaMetaComissao_Service.verificaValores(valores, CDFILIAL, CDPRODUTO, CDCOMISSAO).then(function(response) {
                           if (response.dataset.itcomissao.length !== 0 || field.value() < 0) {
                                if (erro === false) {
                                    //ScreenService.showMessage(mensagens.valorFinal);
                                    ScreenService.showMessage("Valor Final inválido!");
                                    erro = true;
                                }
                                widget.currentRow.VRFINAVENDA = '';
                            }
                        });
                    }
                });
            }
            var valorInicial = parseFloat(widget.getField('VRINICVENDA').value());
            if (valorInicial > valorFinal){
                if (erro === false) {
                    //ScreenService.showMessage(mensagens.valorFinal);
                    ScreenService.showMessage("Valor Final inválido!");
                    erro = true;
                }
                widget.currentRow.VRFINAVENDA = '';
            }
        }
    };

    this.saveProduto = function(widget) {
        widget.currentRow.CDMETAVENDA = widget.getParent().currentRow.CDMETAVENDA;
        General.saveCrud(widget);
    };

    this.saveComissao = function(widget) {
        widget.currentRow.CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
        widget.currentRow.CDPRODUTO = templateManager.container.getWidget('ITENS').currentRow.CDPRODUTO;
        widget.currentRow.CDCOMISSAO = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;

        General.saveCrud(widget);
    };

    this.cadastroAutomaticoItem = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.CDFILIAL = templateManager.container.getWidget('TABBEDITENS').currentRow.CDFILIAL;
            widget.currentRow.CDCOMISSAO = templateManager.container.getWidget('TABELACOMISSAO').currentRow.CDCOMISSAO;

            var widgetActivate = templateManager.container.getWidget('ITENS');
            var rows = {
                PRODUTOS: widget.getParent().getCheckedRows(),
                ROW: widget.currentRow
            };

            Ped03500_tabelaMetaComissao_Service.cadastroAutomaticoItem(rows).then(function(response){
                //ScreenService.showMessage(mensagens.sucessoCadastro);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widget.getParent().unSelectAll();
                widget.currentRow = '';
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOITEM');
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                widgetActivate.activate();
            },
            function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.cadastroAutomaticoProduto = function(widget) {
        var row = widget.currentRow;
        if (widget.isValid()) {
            Ped03500_tabelaMetaComissao_Service.cadastroAutomaticoProduto(row).then(function(response){
                var widgetActivate = templateManager.container.getWidget('PRODUTOS');
                var widgetPopup = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
                widgetPopup.isVisible = false;
                widgetPopup.currentRow = {};
                ScreenService.closePopup(widgetPopup);
                //ScreenService.showMessage(mensagens.sucessoCadastro);
                ScreenService.showMessage("Cadastro automático realizado com sucesso!");
                widgetActivate.activate();
                widgetActivate.reload();
            }, function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };

    this.cancelarCadastroAutomaticoItem = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOITEM');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('TABBEDITENS');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
        widgetActivate.reload();
    };

    this.cancelarCadastroAutomaticoProduto = function() {
        var widget = templateManager.container.getWidget('CADASTROAUTOPRODUTO');
        widget.currentRow = {};
        var widgetActivate = templateManager.container.getWidget('PRODUTOS');
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widgetActivate.activate();
    };

    this.delete = function(widget) {
        var dataSource;
        if (widget.name === 'TABELACOMISSAO') {
            dataSource = 'ped_pedidos#/comissao';
        } else if(widget.name === 'METAVENDA') {
           dataSource = 'ped_pedidos#/metavenda';
        }
        var row = widget.currentRow;
        ScreenService .confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            Ped03500_tabelaMetaComissao_Service.delete(dataSource, row).then(function(response){
                widget.activate();
                ScreenService.closeSwipe();
                widget.reload();
            }, function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        });
    };
}
Configuration(function(ContextRegister){
    ContextRegister.register('Ped03500_tabelaMetaComissao_Controller', Ped03500_tabelaMetaComissao_Controller);
});